<?
	// errors
	define('ERR_API_KEY',  'E2');
	define('ERR_HTTP_404', 'E404');
	// use JPG instead of PNG
	define('USE_JPG',       true);
	//
	define('CACHE_PATH',    './.cache/');
	define('CACHE_AGE', 60*30); // xml cache max age, 30 min here

	// if banner is requested from URL
	if (eregi("banner.php", $_SERVER['PHP_SELF'])){
		display_banner($_GET['key']);
	}
	
function display_banner($api_key){
	// api key must be set
	if($api_key=='') die(ERR_API_KEY);
	// detect language from _GET or from browser settings - fall back to first if not set or unknown
	$lng=get_language($_GET['lang'], array('en', 'fr', 'de'));

	// get character xml
	$cache_name= CACHE_PATH.md5($api_key);
	$cache_xml = $cache_name.'.xml';
    // user LANG in cached image filename
	$cache_png = $cache_name.'_'.$lng.(USE_JPG ? '.jpg' : '.png');
	
	if(file_exists($cache_xml)){
		$cache_mtime=filemtime($cache_xml);
	}else{
		$cache_mtime=0;
	}
    
	$output='';
	// Ryzom API updates xml every hour, we use half hour cache
	if(($cache_mtime+CACHE_AGE)<time()){
		// XML file has expired, get character profile
        try{
            $output = request('http://atys.ryzom.com/characters/index.php?key='.$api_key);
            // Check if there's an error
            if(strlen($output) == 2 && $output[0] == 'E') die($output);
            @file_put_contents($cache_xml, $output);
            // remove cached image as it's out-of-date now
            @unlink($cache_png);
        }catch(Excaption $ex){
            die($ex);
        }
	}
	// if image is NOT found in cache, then we create it
    if(!file_exists($cache_png)){
        if($output==''){
            $output=@file_get_contents($cache_xml);
        }
		if($output=='') die(ERR_API_XML);
		try{
            $xml = @simplexml_load_string($output);
            if($xml==null) die(ERR_API_XML);

            require_once('ryzombanner.class.php');
			$banner = new RyzomBanner($xml, $lng);

			// check if cache is available
			if(file_exists(CACHE_PATH) && is_writable(CACHE_PATH)){
				// save image to cache
				cache_save($cache_png, $banner->getImage(true));
			}else{
				if(USE_JPG){
					header('Content-Type: image/jpeg');
					imagejpeg($banner->getImage());
				}else{
					header('Content-Type: image/png');
					imagepng($banner->getImage());
				}
				exit;
			}
		}catch(Exception $ex){
			die($ex);
		}
    }
	// xml and image is up-to-date, show image
	cache_display($cache_png);
	exit;
}

// this figures out language from URL or from BROWSER settings
function get_language($lng, $knownLanguages){
	if(!in_array($lng, $knownLanguages)){
		$http_lng=explode(',', $_SERVER['HTTP_ACCEPT_LANGUAGE']);
		$found=false;
		foreach($http_lng as $l){
			// get first two chars and test it
			$f=strtolower(substr(trim($l), 0,2));
			if(in_array($f, $knownLanguages)){
				$lng=$f;
				$found=true;
				break;
			}
		}
		if(!$found) $lng=$knownLanguages[0];
	}
	return $lng;
}
// save image to cache
function cache_save($cache_png, $im){
    if(USE_JPG){
        imagejpeg($im, $cache_png, 85);
    }else{
        imagepng($im, $cache_png);
    }
}
// displays cached image file with correct headers
function cache_display($cache_png){

    $if_none_match = $_SERVER['HTTP_IF_NONE_MATCH'];// => "92744f5cc45cd2ef39816d58c5999d3c"
    $if_modified_since= $_SERVER['HTTP_IF_MODIFIED_SINCE'];// => Sat, 11 Apr 2009 14:36:36 GMT

	$size  = filesize($cache_png);
	$mtime = filemtime($cache_png);

	$last_modified=gmstrftime("%a, %d %b %Y %T %Z", $mtime);
	$etag = '"'.md5($cache_png).'"';

	// if this is enabled, half the time connection dies out with HTTP/1.1 200 (and no image)
	/*if( $if_none_match == $etag && $if_modified_since == $last_modified){
		header('HTTP/1.1 304 Not Modified');
		header('Cache-Control: private');
		header('Pragma: ');
		header('Expires: ');
		header('Content-Type: ');
		header('Content-Length: 0');
		header('ETag: '.$etag);
		ob_clean();
		flush();
		exit;
	}else*/{
		if(USE_JPG){
			header('Content-Type: image/jpeg');
		}else{
			header('Content-Type: image/png');
		}
		header('Content-Length: '.$size);
		header('Cache-Control: private');
		header('Pragma: ');
		header('Expires: ');
		header('Last-Modified: '.$last_modified);
		header('ETag: '.$etag);
		ob_clean();
		flush();
		readfile($cache_png);
		exit;
	}
}// output

// return URL content
function request($url) {
	$ch = curl_init();
	curl_setopt($ch, CURLOPT_URL, $url);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
	curl_setopt($ch, CURLOPT_ENCODING , 'gzip');
	$output = curl_exec($ch);
	$ch_info = curl_getinfo($ch);
	if($ch_info['http_code'] !=200 ){ // 200 OK
		throw new Exception(ERR_HTTP_404);
	}
	curl_close($ch);
	return $output;
}
