<?
class GuildIcon {
    /*
     * [code]
     *     header('Content-Type: image/png');
     *     $im=GuildIcon::getImage('pngs/', $_GET['icon']);
     *     imagepng($im);
     * [/code]
     */
    const IMG_COL     = 1;
    const IMG_ADD_NEG = 2;
    const IMG_MUL     = 3;

    function decode($icon){
        // 32bit php does not do 64bit int's so break it up to smaller pieces
        $_cfg = intval(bcmod($icon, 1 << 11)); // back/symbol/invert
        $_color1 = intval(bcmod(bcdiv($icon, 1 << 11), 0x1000000)); // rgb for first color
        $_color2 = intval(bcmod(bcdiv(bcdiv($icon, 1 << 11), 1 << 24), 0x1000000)); // rgb for second colorc
        //
		$ret=new stdClass();
		$ret->back = ($_cfg & 15)-1;
		$ret->symbol = ($_cfg >> 4 & 63) -1;
		$ret->invert = ($_cfg >> 10) & 1;
        // first color
		$ret->col_1r = ($_color1 & 255);
		$ret->col_1g = ($_color1 >> 8) & 255;
		$ret->col_1b = ($_color1 >> 16) & 255;
        // second color
		$ret->col_2r = ($_color2 & 255);
		$ret->col_2g = ($_color2 >> 8) & 255;
		$ret->col_2b = ($_color2 >> 16) & 255;
		
		// WARNING: this only works on 64bit systems
        /*$ret=new stdClass();
        $ret->back   =($icon & 15)-1;
        $ret->symbol =($icon >>  4 & 63) -1;
        $ret->invert = $icon >> 10 & 1;
        $ret->col_1r = $icon >> 11 & 255;
        $ret->col_1g = $icon >> 19 & 255;
        $ret->col_1b = $icon >> 27 & 255;
        $ret->col_2r = $icon >> 35 & 255;
        $ret->col_2g = $icon >> 43 & 255;
        $ret->col_2b = $icon >> 51 & 255;
        */
        // if $icon is 0, we need to fix this
        if($ret->back < 0) $ret->back=0;
        if($ret->symbol < 0) $ret->symbol=0;
        return $ret;
    }

    function getImage($pngs, $icon, $size='b'){
        $data = GuildIcon::decode($icon);

		// fall back to 64x64 images
		if($size!='b' && $size!='s') $size='b';

        // filenames
        $img_back = sprintf('guild_back_%s_%02d_1.png', $size, $data->back);
        $img_back2 = sprintf('guild_back_%s_%02d_2.png', $size, $data->back);
        $img_symbol = sprintf('guild_symbol_%s_%02d.png', $size, $data->symbol);
        
        // colorize backgrounds and join them to one
        $im=imagecreatefrompng($pngs.'/'.$img_back);
        $im_w = imagesx($im);
        $im_h = imagesx($im);
        $im=GuildIcon::my_imagefilter($im, GuildIcon::IMG_COL, $data->col_1r, $data->col_1g, $data->col_1b);

        // second background
        $tmp=imagecreatefrompng($pngs.'/'.$img_back2);
        $tmp=GuildIcon::my_imagefilter($tmp, GuildIcon::IMG_COL, $data->col_2r, $data->col_2g, $data->col_2b);
        // join
        imagecopy($im, $tmp, 0,0, 0, 0, $im_w, $im_h);

        // get the symbol
        $tmp=imagecreatefrompng($pngs.'/'.$img_symbol);

        if($data->invert == 1){
            $im=GuildIcon::my_imagefilter($im, GuildIcon::IMG_ADD_NEG, $tmp);
        }else{
            $im=GuildIcon::my_imagefilter($im, GuildIcon::IMG_MUL, $tmp);
        }
        
        return $im;
    }

    function my_imagefilter($im, $filtertype, $arg0=0, $arg1=0, $arg2=0){
        $imgw=imagesx($im);
        $imgh=imagesy($im);

        $out=imagecreatetruecolor($imgw, $imgh);
        imagesavealpha($out, true);
        $trans = imagecolorallocatealpha($out, 0, 0, 0, 127);
        imagefill($out, 0, 0, $trans);
        imagecolortransparent($out, $trans);

        for($x=0;$x<$imgw;$x++){
            for($y=0;$y<$imgh;$y++){
                $rgb=imagecolorat($im, $x, $y);
                $rgba=imagecolorsforindex($im, $rgb);
                $a=$rgba['alpha'];
                $r=$rgba['red'];
                $g=$rgba['green'];
                $b=$rgba['blue'];
                switch($filtertype){
                    case GuildIcon::IMG_COL:
                        $r=$arg0; $g=$arg1; $b=$arg2;
                        break;
                    case GuildIcon::IMG_MUL:
                        $rgba2=imagecolorsforindex($arg0, imagecolorat($arg0, $x, $y));
                        $r=$r*$rgba2['red']/255;
                        $g=$g*$rgba2['green']/255;
                        $b=$b*$rgba2['blue']/255;
                        break;
                    case GuildIcon::IMG_ADD_NEG:
                        $rgba2=imagecolorsforindex($arg0, imagecolorat($arg0, $x, $y));
                        $r=$r+255-$rgba2['red'];
                        $g=$g+255-$rgba2['green'];
                        $b=$b+255-$rgba2['blue'];
                        // cap color values to 255
                        if($r>255)$r=255;
                        if($g>255)$g=255;
                        if($b>255)$b=255;
                        break;
                }// switch
                $val = imagecolorallocatealpha($im, $r, $g, $b, $a);
                imagesetpixel($out, $x, $y, $val);
            }// for y
        }// for x
        return $out;
    }
}// Class

